diff --git a/lisp/faces.el b/lisp/faces.el
index fa526c3..9e5d51e 100644
--- a/lisp/faces.el
+++ b/lisp/faces.el
@@ -2500,6 +2500,310 @@ unwanted effects."
   :group 'basic-faces
   :group 'display-line-numbers)
 
+
+;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
+;;; begin MULTIPLE-CURSORS
+
+(defface +-debugging-face
+  '((t (:foreground "OrangeRed")))
+  "Face for `+-debugging-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-special-character-face
+  '((t (:foreground "cyan")))
+  "Face for `+-special-character-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-vertical-bar-face
+  '((t (:foreground "magenta")))
+  "Face for `+-vertical-bar-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-reversed-vertical-bar-face
+  '((t (:foreground "cyan")))
+  "Face for `+-reversed-vertical-bar-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-even-numbered-column-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "DarkCyan")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "DarkCyan")
+    (((class color) (min-colors 88) (background light))
+     :foreground "DarkCyan")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-even-numbered-column-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-odd-numbered-column-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "red")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "red")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "red")
+    (((class color) (min-colors 88) (background light))
+     :foreground "red")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-odd-numbered-column-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-even-numbered-column-inactive-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "#eee8aa")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "blue")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "blue")
+    (((class color) (min-colors 88) (background light))
+     :foreground "blue")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-even-numbered-column-inactive-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-odd-numbered-column-inactive-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "#ff6347")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "orange")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "orange")
+    (((class color) (min-colors 88) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-odd-numbered-column-inactive-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-beyond-fill-column-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "green")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "green")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "green")
+    (((class color) (min-colors 88) (background light))
+     :foreground "green")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-beyond-fill-column-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-beyond-fill-column-inactive-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "#2e8b57")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "#2e8b57")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "#2e8b57")
+    (((class color) (min-colors 88) (background light))
+     :foreground "#2e8b57")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `+-beyond-fill-column-inactive-face'.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface +-real-fake-cursor-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "cyan" :background "DarkBlue")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "magenta" :background "LightSkyBlue")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "magenta" :background "LightSkyBlue")
+    (((class color) (min-colors 88) (background light))
+     :foreground "magenta" :background "LightSkyBlue")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow" :background "blue3")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange" :background "lightgoldenrod2")
+    (((class color) (min-colors 8))
+     :foreground "white" :background "blue")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink" :background "gray"))
+  "Face for `+-real-fake-cursor-face'.  Used in `xdisp.c'.
+As to a hollow style cursor, the :foreground parameter is used for the border and
+the :background parameter is used for the inner filled shading.  The character
+retains its own foreground color and is unaffected by this particular face."
+  :group '+-mode)
+
+(defface +-real-fake-cursor-inactive-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "#ff00ff" :background "ForestGreen")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "OrangeRed" :background "grey70")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "OrangeRed" :background "grey70")
+    (((class color) (min-colors 88) (background light))
+     :foreground "OrangeRed" :background "grey70")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow" :background "blue3")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange" :background "lightgoldenrod2")
+    (((class color) (min-colors 8))
+     :foreground "white" :background "blue")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink" :background "gray"))
+  "Face for `+-real-fake-cursor-inactive-face'.  Used in `xdisp.c'.
+As to a hollow style cursor, the :foreground parameter is used for the border and
+the :background parameter is used for the inner filled shading.  The character
+retains its own foreground color and is unaffected by this particular face."
+  :group '+-mode)
+
+(defface +-real-fake-cursor-region-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "chocolate4" :background "#8b795e")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "pink" :background "black")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "pink" :background "black")
+    (((class color) (min-colors 88) (background light))
+     :foreground "pink" :background "black")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow" :background "blue3")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange" :background "lightgoldenrod2")
+    (((class color) (min-colors 8))
+     :foreground "white" :background "blue")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink" :background "gray"))
+  "Face for `+-real-fake-cursor-region-face'.  Used in `xdisp.c'.
+As to a hollow style cursor, the :foreground parameter is used for the inner
+filled shading when PT is _not_ within the active region; and, the :background
+parameter is used for the inner filled shading when PT _is_ within the active
+region.  The character retains its own foreground color and is unaffected by this
+particular face."
+  :group '+-mode)
+
+(defface +-overlay-arrow-face
+  '((t (:foreground "red")))
+  "Face for `+-overlay-arrow-face'."
+  :group '+-mode)
+
+(defface +-overlay-arrow-inactive-face
+  '((t (:foreground "DarkSlateGrey")))
+  "Face for `+-overlay-arrow-inactive-face'."
+  :group '+-mode)
+
+(defface +-overlay-arrow-hscl-face
+  '((t (:foreground "DarkGreen")))
+  "Face for `+-overlay-arrow-hscl-face'."
+  :group '+-mode)
+
+(defface +-overlay-arrow-hscl-inactive-face
+  '((t (:foreground "DarkSlateGrey")))
+  "Face for `+-overlay-arrow-hscl-inactive-face'."
+  :group '+-mode)
+
+(defface fc-face
+  '((((class color) (min-colors 88) (background dark) (type ns))
+     :foreground "grey15")
+    (((class color) (min-colors 88) (background dark) (type gtk))
+         :foreground "grey15")
+    (((class color) (min-colors 88) (background dark) (type w32))
+         :foreground "grey25")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "purple")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "purple")
+    (((class color) (min-colors 88) (background light))
+     :foreground "purple")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `fc-face' in the active window.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface fc-inactive-face
+  '((((class color) (min-colors 88) (background dark))
+     :foreground "DarkBlue")
+    (((class color) (min-colors 88) (background light) (type gtk))
+     :foreground "grey15")
+    (((class color) (min-colors 88) (background light) (type ns))
+     :foreground "grey15")
+    (((class color) (min-colors 88) (background light))
+     :foreground "grey15")
+    (((class color) (min-colors 16) (background dark))
+     :foreground "yellow")
+    (((class color) (min-colors 16) (background light))
+     :foreground "orange")
+    (((class color) (min-colors 8))
+     :foreground "white")
+    (((type tty) (class mono))
+     :inverse-video t)
+    (t :foreground "pink"))
+  "Face for `fc-inactive-face' in the inactive window.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface fc-opoint-face
+  '((t (:foreground "magenta")))
+  "Face for `fc-opoint-face' in the active window.  Used in `xdisp.c'."
+  :group '+-mode)
+
+(defface fc-opoint-inactive-face
+  '((t (:foreground "cyan")))
+  "Face for `fc-opoint-inactive-face' in the inactive window.  Used in `xdisp.c'."
+  :group '+-mode)
+
+;;; end MULTIPLE-CURSORS
+;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
+
+
 (defface escape-glyph
   '((((background dark)) :foreground "cyan")
     ;; See the comment in minibuffer-prompt for
diff --git a/src/buffer.c b/src/buffer.c
index ab47748..4aa745a 100644
--- a/src/buffer.c
+++ b/src/buffer.c
@@ -133,6 +133,69 @@ CHECK_OVERLAY (Lisp_Object x)
 
 /* These setters are used only in this file, so they can be private.
    The public setters are inline functions defined in buffer.h.  */
+
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+static void
+bset_mc_real_fake_cursor (struct buffer *b, Lisp_Object val)
+{
+  b->mc_real_fake_cursor_ = val;
+}
+
+static void
+bset_mc_conf (struct buffer *b, Lisp_Object val)
+{
+  b->mc_conf_ = val;
+}
+
+static void
+bset_mc_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->mc_inactive_windows_ = val;
+}
+
+static void
+bset_crosshairs (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_ = val;
+}
+
+static void
+bset_ch_horizontal_ruler (struct buffer *b, Lisp_Object val)
+{
+  b->ch_horizontal_ruler_ = val;
+}
+
+static void
+bset_ch_vertical_ruler (struct buffer *b, Lisp_Object val)
+{
+  b->ch_vertical_ruler_ = val;
+}
+
+static void
+bset_ch_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->ch_inactive_windows_ = val;
+}
+
+static void
+bset_fc_visible (struct buffer *b, Lisp_Object val)
+{
+  b->fc_visible_ = val;
+}
+
+static void
+bset_fc_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->fc_inactive_windows_ = val;
+}
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
 static void
 bset_abbrev_mode (struct buffer *b, Lisp_Object val)
 {
@@ -5142,6 +5205,24 @@ init_buffer_once (void)
   bset_last_selected_window (&buffer_local_flags, make_fixnum (0));
 
   idx = 1;
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  XSETFASTINT (BVAR (&buffer_local_flags, mc_real_fake_cursor), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, mc_conf), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, mc_inactive_windows), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, crosshairs), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, ch_horizontal_ruler), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, ch_vertical_ruler), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, ch_inactive_windows), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, fc_visible), idx); ++idx;
+  XSETFASTINT (BVAR (&buffer_local_flags, fc_inactive_windows), idx); ++idx;
+
+/* *************************************************************************** */
+
+
   XSETFASTINT (BVAR (&buffer_local_flags, mode_line_format), idx); ++idx;
   XSETFASTINT (BVAR (&buffer_local_flags, abbrev_mode), idx); ++idx;
   XSETFASTINT (BVAR (&buffer_local_flags, overwrite_mode), idx); ++idx;
@@ -5228,6 +5309,24 @@ init_buffer_once (void)
   /* Must do these before making the first buffer! */
 
   /* real setup is done in bindings.el */
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  bset_mc_real_fake_cursor (&buffer_defaults, Qhollow);
+  bset_mc_conf (&buffer_defaults, Qnil);
+  bset_mc_inactive_windows (&buffer_defaults, Qt);
+  bset_crosshairs (&buffer_defaults, Qnil);
+  bset_ch_horizontal_ruler (&buffer_defaults, Qt);
+  bset_ch_vertical_ruler (&buffer_defaults, Qt);
+  bset_ch_inactive_windows (&buffer_defaults, Qt);
+  bset_fc_visible (&buffer_defaults, Qnil);
+  bset_fc_inactive_windows (&buffer_defaults, Qt);
+
+/* *************************************************************************** */
+
+
   bset_mode_line_format (&buffer_defaults, build_pure_c_string ("%-"));
   bset_header_line_format (&buffer_defaults, Qnil);
   bset_abbrev_mode (&buffer_defaults, Qnil);
@@ -5458,6 +5557,51 @@ defvar_per_buffer (struct Lisp_Buffer_Objfwd *bo_fwd, const char *namestring,
 void
 syms_of_buffer (void)
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  DEFSYM (Qmc_real_fake_cursor, "mc-real-fake-cursor");
+  DEFVAR_PER_BUFFER ("mc-real-fake-cursor", &BVAR (current_buffer, mc_real_fake_cursor), Qnil,
+    doc: /* A bufer-local variable to set the cursor type of the real fake cursor. */);
+
+  DEFSYM (Qmc_conf, "mc-conf");
+  DEFVAR_PER_BUFFER ("mc-conf", &BVAR (current_buffer, mc_conf), Qnil,
+    doc: /* A bufer-local variable to store the value of the multiple cursors to be displayed
+during the next redisplay. */);
+
+  DEFSYM (Qmc_inactive_windows, "mc-inactive-windows");
+  DEFVAR_PER_BUFFER ("mc-inactive-windows", &BVAR (current_buffer, mc_inactive_windows), Qnil,
+    doc: /* When non-nil, draw multiple cursors in inactive windows. */);
+
+  DEFSYM (Qcrosshairs, "crosshairs");
+  DEFVAR_PER_BUFFER ("crosshairs", &BVAR (current_buffer, crosshairs), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate crosshairs. */);
+
+  DEFSYM (Qch_horizontal_ruler, "ch-horizontal-ruler");
+  DEFVAR_PER_BUFFER ("ch-horizontal-ruler", &BVAR (current_buffer, ch_horizontal_ruler), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate the crosshairs horizontal ruler. */);
+
+  DEFSYM (Qch_vertical_ruler, "ch-vertical-ruler");
+  DEFVAR_PER_BUFFER ("ch-vertical-ruler", &BVAR (current_buffer, ch_vertical_ruler), Qnil,
+    doc: /* A bufer-local variable to activate/deactivate the crosshairs vertical ruler. */);
+
+  DEFSYM (Qch_inactive_windows, "ch-inactive-windows");
+  DEFVAR_PER_BUFFER ("ch-inactive-windows", &BVAR (current_buffer, ch_inactive_windows), Qnil,
+    doc: /* When non-nil, draw crosshairs in inactive windows. */);
+
+  DEFSYM (Qfc_visible, "fc-visible");
+  DEFVAR_PER_BUFFER ("fc-visible", &BVAR (current_buffer, fc_visible), Qnil,
+    doc: /* A bufer-local variable to turn on/off the multiple cursors fill column. */);
+
+  DEFSYM (Qfc_visible_inactive_window, "fc-inactive-window");
+  DEFVAR_PER_BUFFER ("fc-inactive-windows", &BVAR (current_buffer, fc_inactive_windows), Qnil,
+    doc: /* When non-nil, draw multiple cursors fill column in inactive windows. */);
+
+/* *************************************************************************** */
+
+
   staticpro (&last_overlay_modification_hooks);
   last_overlay_modification_hooks = make_nil_vector (10);
 
diff --git a/src/buffer.h b/src/buffer.h
index f42c3e9..189fac5 100644
--- a/src/buffer.h
+++ b/src/buffer.h
@@ -736,6 +736,40 @@ struct buffer
      in the display of this buffer.  */
   Lisp_Object extra_line_spacing_;
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  /* The cursor type of the real fake cursor. */
+  Lisp_Object mc_real_fake_cursor_;
+
+  /* The name of list used by multiple cursors for next redisplay. */
+  Lisp_Object mc_conf_;
+
+  /* Whether to draw multiple cursors in inactive windows. */
+  Lisp_Object mc_inactive_windows_;
+
+  /* The name of the buffer-local variable. */
+  Lisp_Object crosshairs_;
+
+  /* The name of the crosshairs horizontal ruler. */
+  Lisp_Object ch_horizontal_ruler_;
+
+  /* The name of the crosshairs vertical ruler. */
+  Lisp_Object ch_vertical_ruler_;
+
+  /* Whether to draw crosshairs in inactive windows. */
+  Lisp_Object ch_inactive_windows_;
+
+  /* The name of the buffer-local variable. */
+  Lisp_Object fc_visible_;
+
+  /* Whether to draw multiple cursors fill column in inactive windows. */
+  Lisp_Object fc_inactive_windows_;
+
+/* *************************************************************************** */
+
+
   /* Cursor type to display in non-selected windows.
      t means to use hollow box cursor.
      See `cursor-type' for other values.  */
@@ -787,14 +821,21 @@ struct buffer
      an indirect buffer since it counts as its base buffer.  */
   int window_count;
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
   /* A non-zero value in slot IDX means that per-buffer variable
      with index IDX has a local value in this buffer.  The index IDX
      for a buffer-local variable is stored in that variable's slot
      in buffer_local_flags as a Lisp integer.  If the index is -1,
      this means the variable is always local in all buffers.  */
-#define MAX_PER_BUFFER_VARS 50
+#define MAX_PER_BUFFER_VARS 60
   char local_flags[MAX_PER_BUFFER_VARS];
 
+/* *************************************************************************** */
+
+
   /* Set to the modtime of the visited file when read or written.
      modtime.tv_nsec == NONEXISTENT_MODTIME_NSECS means
      visited file was nonexistent.  modtime.tv_nsec ==
@@ -903,6 +944,69 @@ XBUFFER (Lisp_Object a)
 /* Most code should use these functions to set Lisp fields in struct
    buffer.  (Some setters that are private to a single .c file are
    defined as static in those files.)  */
+
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+INLINE void
+bset_blv_mc_real_fake_cursor (struct buffer *b, Lisp_Object val)
+{
+  b->mc_real_fake_cursor_ = val;
+}
+
+INLINE void
+bset_blv_mc_conf (struct buffer *b, Lisp_Object val)
+{
+  b->mc_conf_ = val;
+}
+
+INLINE void
+bset_blv_mc_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->mc_inactive_windows_ = val;
+}
+
+INLINE void
+bset_blv_crosshairs (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_ = val;
+}
+
+INLINE void
+bset_blv_ch_horizontal_ruler (struct buffer *b, Lisp_Object val)
+{
+  b->ch_horizontal_ruler_ = val;
+}
+
+INLINE void
+bset_blv_ch_vertical_ruler (struct buffer *b, Lisp_Object val)
+{
+  b->ch_vertical_ruler_ = val;
+}
+
+INLINE void
+bset_blv_ch_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->ch_inactive_windows_ = val;
+}
+
+INLINE void
+bset_blv_fc_visible (struct buffer *b, Lisp_Object val)
+{
+  b->fc_visible_ = val;
+}
+
+INLINE void
+bset_blv_fc_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->fc_inactive_windows_ = val;
+}
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
 INLINE void
 bset_bidi_paragraph_direction (struct buffer *b, Lisp_Object val)
 {
diff --git a/src/dispextern.h b/src/dispextern.h
index 1a53656..d689a2d 100644
--- a/src/dispextern.h
+++ b/src/dispextern.h
@@ -100,6 +100,36 @@ typedef int Cursor;
 #define NativeRectangle int
 #endif
 
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+/* Forward prototype definitions. */
+enum type_of_cache;
+
+enum type_of_cursor;
+
+enum mc_flavor;
+
+enum type_of_action
+{
+  MULTIPLE_CURSORS,
+  HORIZONTAL_RULER,
+  VERTICAL_RULER,
+  FILL_COLUMN
+};
+
+struct mc_RGB
+{
+  double red;
+  double green;
+  double blue;
+};
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
 /* Text cursor types.  */
 
 enum text_cursor_kinds
@@ -382,6 +412,20 @@ struct glyph_slice
 
 struct glyph
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  int x, y, hpos, vpos;
+
+  int relative_x;
+
+  bool_bf zv_p : 1;
+
+/* *************************************************************************** */
+
+
   /* Position from which this glyph was drawn.  If `object' below is a
      Lisp string, this is an index into that string.  If it is a
      buffer, this is a position in that buffer.  In addition, some
@@ -1248,6 +1292,28 @@ enum draw_glyphs_face
 
 struct glyph_string
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+    bool_bf left_overwritten_p : 1;
+
+    bool_bf right_overwritten_p : 1;
+
+    bool_bf rectangle_nuked_p : 1;
+
+    bool_bf background_nuked_p : 1;
+
+    enum draw_glyph_action
+    {
+      MC_DRAW_GLYPH,
+      MC_ERASE_GLYPH
+    } action_type;
+
+/* *************************************************************************** */
+
+
   /* X-origin of the string.  */
   int x;
 
@@ -2216,6 +2282,16 @@ struct composition_it
 
 struct it
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  bool_bf zv_p : 1;
+
+/* *************************************************************************** */
+
+
   /* The window in which we iterate over current_buffer (or a string).  */
   Lisp_Object window;
   struct window *w;
@@ -2812,6 +2888,31 @@ typedef void (*frame_parm_handler) (struct frame *, Lisp_Object, Lisp_Object);
 
 struct redisplay_interface
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+/* `redisplay_interface' in `nsterm.m` \ `w32term.c` \ `xterm.c` must be in the
+exact same order as the `redisplay_interface' in `dispextern.h`! */
+
+  void (*mc_scribe_glyphs) (struct window *w, struct glyph_matrix *matrix, struct glyph_row *row,
+        struct glyph *string, enum glyph_row_area area, int len, int vpos,
+        int bottom_vpos, struct mc_RGB lsl, enum mc_flavor glyph_flavor,
+        enum type_of_cursor cursor_type, int wd, bool active_p, bool cursor_gc_p);
+
+  void (*mc_scribe_cursor) (struct window *w, struct glyph_matrix *matrix,
+        struct glyph_row *glyph_row, int x, int fx, int y, int fy, int hpos,
+        int vpos, int wd, int h, struct mc_RGB lsl, enum type_of_cursor cursor_type,
+        int cursor_width, enum mc_flavor glyph_flavor, bool on_p, bool active_p);
+
+  void (*mc_scribe_string) (struct glyph_string *s, struct glyph_matrix *matrix, struct glyph_row *row,
+        struct mc_RGB lsl, enum mc_flavor glyph_flavor,
+        enum type_of_cursor cursor_type, int wd, bool active_p, bool cursor_gc_p);
+
+/* *************************************************************************** */
+
+
   /* Handlers for setting frame parameters.  */
   frame_parm_handler *frame_parm_handlers;
 
@@ -3270,6 +3371,67 @@ extern void get_font_ascent_descent (struct font *, int *, int *);
 
 #ifdef HAVE_WINDOW_SYSTEM
 
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+extern Lisp_Object mc_listn (ptrdiff_t, Lisp_Object, ...);
+
+extern Lisp_Object mc_nth (int, Lisp_Object);
+
+extern Lisp_Object mc_assq (Lisp_Object, Lisp_Object);
+
+extern void mc_xw_color_values (struct window *, Lisp_Object, struct mc_RGB *);
+
+extern bool mc_update_window_fringes (struct window *, bool);
+
+extern char * mc_window (struct window *);
+
+extern char * mc_char_to_string (int);
+
+extern char * mc_cursor_type_to_string (enum type_of_cursor);
+
+extern char * mc_flavor_to_string (enum mc_flavor);
+
+extern void mc_draw_fringe_bitmap (struct window *, struct glyph_row *, int,
+                                   enum type_of_cursor);
+
+extern int mc_get_fringe_bitmap (struct window *, Lisp_Object, int, int);
+
+extern void mc_engine (struct window *, struct glyph_matrix *, struct glyph_row *,
+                       struct glyph *, int, int, int, int, int, int,
+                       enum type_of_cursor, int, struct glyph_matrix *, int,
+                       struct mc_RGB, bool, enum type_of_action, bool,
+                       enum type_of_cache);
+
+extern void mc_set_essentials (struct window *, bool, struct mc_RGB *,
+                               struct mc_RGB *, int *);
+
+extern void mc_draw_row (struct window *, struct glyph_matrix *, struct glyph_row *,
+                         struct glyph *, int, int, int, int, bool, struct glyph_matrix *,
+                         int, struct mc_RGB, struct mc_RGB, bool);
+
+extern void mc_redraw_row (struct window *, struct glyph_matrix *, struct glyph_row *,
+                           int, int, int, bool, enum draw_glyphs_face);
+
+extern void mc_reset_cache (struct window *, enum type_of_cache);
+
+extern void mc_pre_scroll_clean (struct window *);
+
+extern void mc_draw_cursor_glyph (struct window *, struct glyph_matrix *,
+                                  struct glyph_row *, enum draw_glyphs_face,
+                                  int, int, int, struct mc_RGB, enum mc_flavor,
+                                  enum type_of_cursor, int, bool, bool);
+
+extern void mc_x_write_glyphs (struct window *, struct glyph_matrix *, struct glyph_row *,
+                               struct glyph *, enum glyph_row_area, int,
+                               int, int, struct mc_RGB, enum mc_flavor,
+                               enum type_of_cursor, int, bool, bool);
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
 #ifdef GLYPH_DEBUG
 extern void dump_glyph_string (struct glyph_string *) EXTERNALLY_VISIBLE;
 #endif
